--- //depot/vendor/freebsd/src/sys/dev/vx/if_vx.c	2005/07/22 11:30:27
+++ //depot/projects/netsmp/src/sys/dev/vx/if_vx.c	2005/08/05 14:11:40
@@ -245,8 +245,8 @@
 	vxmbuffill((caddr_t) sc);
 
 	/* Interface is now `running', with no output active. */
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	/* Attempt to start output, if any. */
 	vxstart(ifp);
@@ -405,8 +405,8 @@
 	int sh, len, pad;
 
 	/* Don't transmit if interface is busy or not running */
-	if ((sc->ifp->if_flags &
-	    (IFF_RUNNING | IFF_OACTIVE)) != IFF_RUNNING)
+	if ((sc->ifp->if_drv_flags &
+	    (IFF_DRV_RUNNING | IFF_DRV_OACTIVE)) != IFF_DRV_RUNNING)
 		return;
 
 startagain:
@@ -439,7 +439,7 @@
 		    SET_TX_AVAIL_THRESH | ((len + pad + 4) >> 2));
 		/* not enough room in FIFO - make sure */
 		if (CSR_READ_2(sc, VX_W1_FREE_TX) < len + pad + 4) {
-			ifp->if_flags |= IFF_OACTIVE;
+			ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 			ifp->if_timer = 1;
 			return;
 		}
@@ -585,7 +585,7 @@
 		} else if (i & TXS_MAX_COLLISION) {
 			++sc->ifp->if_collisions;
 			CSR_WRITE_2(sc, VX_COMMAND, TX_ENABLE);
-			sc->ifp->if_flags &= ~IFF_OACTIVE;
+			sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 		} else
 			sc->tx_succ_ok = (sc->tx_succ_ok + 1) & 127;
 	}
@@ -619,7 +619,7 @@
 			vxread(sc);
 		if (status & S_TX_AVAIL) {
 			ifp->if_timer = 0;
-			sc->ifp->if_flags &= ~IFF_OACTIVE;
+			sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 			vxstart(sc->ifp);
 		}
 		if (status & S_CARD_FAILURE) {
@@ -854,15 +854,15 @@
 	switch (cmd) {
 	case SIOCSIFFLAGS:
 		if ((ifp->if_flags & IFF_UP) == 0 &&
-		    (ifp->if_flags & IFF_RUNNING) != 0) {
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING) != 0) {
 			/*
 	                 * If interface is marked up and it is stopped, then
 	                 * start it.
 	                 */
 			vxstop(sc);
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 		} else if ((ifp->if_flags & IFF_UP) != 0 &&
-		    (ifp->if_flags & IFF_RUNNING) == 0) {
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 			/*
 	                 * If interface is marked up and it is stopped, then
 	                 * start it.
@@ -930,7 +930,7 @@
 
 	if (ifp->if_flags & IFF_DEBUG)
 		if_printf(ifp, "device timeout\n");
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	vxstart(ifp);
 	vxintr(sc);
 }
--- //depot/vendor/freebsd/src/sys/dev/wi/if_wi.c	2005/08/05 05:00:34
+++ //depot/projects/netsmp/src/sys/dev/wi/if_wi.c	2005/08/05 14:21:31
@@ -629,7 +629,7 @@
 		wi_tx_ex_intr(sc);
 	if (status & WI_EV_INFO)
 		wi_info_intr(sc);
-	if ((ifp->if_flags & IFF_OACTIVE) == 0 &&
+	if ((ifp->if_drv_flags & IFF_DRV_OACTIVE) == 0 &&
 	    (sc->sc_flags & WI_FLAGS_OUTRANGE) == 0 &&
 	    !IFQ_DRV_IS_EMPTY(&ifp->if_snd))
 		wi_start(ifp);
@@ -792,8 +792,8 @@
 	wi_cmd(sc, WI_CMD_ENABLE | sc->sc_portnum, 0, 0, 0);
 
 	sc->sc_enabled = 1;
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	if (ic->ic_opmode == IEEE80211_M_AHDEMO ||
 	    ic->ic_opmode == IEEE80211_M_IBSS ||
 	    ic->ic_opmode == IEEE80211_M_MONITOR ||
@@ -866,7 +866,7 @@
 	sc->sc_scan_timer = 0;
 	sc->sc_false_syns = 0;
 	sc->sc_naps = 0;
-	ifp->if_flags &= ~(IFF_OACTIVE | IFF_RUNNING);
+	ifp->if_drv_flags &= ~(IFF_DRV_OACTIVE | IFF_DRV_RUNNING);
 	ifp->if_timer = 0;
 
 	WI_UNLOCK(sc);
@@ -902,7 +902,7 @@
 		IF_POLL(&ic->ic_mgtq, m0);
 		if (m0 != NULL) {
 			if (sc->sc_txd[cur].d_len != 0) {
-				ifp->if_flags |= IFF_OACTIVE;
+				ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 				break;
 			}
 			IF_DEQUEUE(&ic->ic_mgtq, m0);
@@ -930,7 +930,7 @@
 				break;
 			if (sc->sc_txd[cur].d_len != 0) {
 				IFQ_DRV_PREPEND(&ifp->if_snd, m0);
-				ifp->if_flags |= IFF_OACTIVE;
+				ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 				break;
 			}
 			if (m0->m_len < sizeof(struct ether_header) &&
@@ -1121,7 +1121,7 @@
 		WI_LOCK(sc);
 		if (ifp->if_flags & IFF_UP) {
 			if (ic->ic_opmode != IEEE80211_M_HOSTAP &&
-			    ifp->if_flags & IFF_RUNNING) {
+			    ifp->if_drv_flags & IFF_DRV_RUNNING) {
 				if (ifp->if_flags & IFF_PROMISC &&
 				    !(sc->sc_if_flags & IFF_PROMISC)) {
 					wi_write_val(sc, WI_RID_PROMISC, 1);
@@ -1135,7 +1135,7 @@
 				wi_init(sc);
 			}
 		} else {
-			if (ifp->if_flags & IFF_RUNNING) {
+			if (ifp->if_drv_flags & IFF_DRV_RUNNING) {
 				wi_stop(ifp, 1);
 			}
 			sc->wi_gone = 0;
@@ -1164,7 +1164,7 @@
 		error = copyin(ifr->ifr_data, &wreq, sizeof(wreq));
 		if (error)
 			break;
-		if (!(ifp->if_flags & IFF_RUNNING) ||
+		if (!(ifp->if_drv_flags & IFF_DRV_RUNNING) ||
 		    sc->sc_firmware_type == WI_LUCENT) {
 			error = EIO;
 			break;
@@ -1631,7 +1631,7 @@
 	sc->sc_txd[cur].d_len = 0;
 	sc->sc_txcur = cur = (cur + 1) % sc->sc_ntxbuf;
 	if (sc->sc_txd[cur].d_len == 0)
-		ifp->if_flags &= ~IFF_OACTIVE;
+		ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	else {
 		if (wi_cmd(sc, WI_CMD_TX | WI_RECLAIM, sc->sc_txd[cur].d_fid,
 		    0, 0)) {
--- //depot/vendor/freebsd/src/sys/dev/wi/if_wi_pci.c	2005/03/01 07:52:07
+++ //depot/projects/netsmp/src/sys/dev/wi/if_wi_pci.c	2005/08/05 14:11:40
@@ -267,7 +267,7 @@
 
 	if (ifp->if_flags & IFF_UP) {
 		ifp->if_init(ifp->if_softc);
-		if (ifp->if_flags & IFF_RUNNING)
+		if (ifp->if_drv_flags & IFF_DRV_RUNNING)
 			ifp->if_start(ifp);
 	}
 
--- //depot/vendor/freebsd/src/sys/dev/wl/if_wl.c	2005/08/03 00:20:47
+++ //depot/projects/netsmp/src/sys/dev/wl/if_wl.c	2005/08/05 14:11:40
@@ -810,12 +810,12 @@
     WL_LOCK(sc);
     oldpri = splimp();
     if ((stat = wlhwrst(sc)) == TRUE) {
-	sc->ifp->if_flags |= IFF_RUNNING;   /* same as DSF_RUNNING */
+	sc->ifp->if_drv_flags |= IFF_DRV_RUNNING;   /* same as DSF_RUNNING */
 	/* 
 	 * OACTIVE is used by upper-level routines
 	 * and must be set
 	 */
-	sc->ifp->if_flags &= ~IFF_OACTIVE;  /* same as tbusy below */
+	sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;  /* same as tbusy below */
 		
 	sc->flags |= DSF_RUNNING;
 	sc->tbusy = 0;
@@ -990,7 +990,7 @@
 	   (cu_status & AC_SW_B) == 0){
 	    sc->tbusy = 0;
 	    untimeout(wlwatchdog, sc, sc->watchdog_ch);
-	    sc->ifp->if_flags &= ~IFF_OACTIVE;
+	    sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	    /*
 	     * This is probably just a race.  The xmt'r is just
 	     * became idle but WE have masked interrupts so ...
@@ -1027,11 +1027,11 @@
 	 */
 	/* try 10 ticks, not very long */
 	sc->watchdog_ch = timeout(wlwatchdog, sc, 10);
-	sc->ifp->if_flags |= IFF_OACTIVE;
+	sc->ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 	sc->ifp->if_opackets++;
 	wlxmt(sc, m);
     } else {
-	sc->ifp->if_flags &= ~IFF_OACTIVE;
+	sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
     }
     WL_UNLOCK(sc);
     return;
@@ -1074,7 +1074,7 @@
     if (sc->ifp->if_flags & IFF_DEBUG)
 	printf("wl%d: entered wlread()\n", sc->unit);
 #endif
-    if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+    if (!((ifp->if_flags & IFF_UP) && (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 	printf("%s read(): board is not running.\n", ifp->if_xname);
 	sc->hacr &= ~HACR_INTRON;
 	CMD(sc);		/* turn off interrupts */
@@ -1627,7 +1627,7 @@
 	    }
 	    sc->tbusy = 0;
 	    untimeout(wlwatchdog, sc, sc->watchdog_ch);
-	    sc->ifp->if_flags &= ~IFF_OACTIVE;
+	    sc->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	    wlstart(sc->ifp);
 	}
     }
--- //depot/vendor/freebsd/src/sys/dev/xe/if_xe.c	2005/08/03 00:20:47
+++ //depot/projects/netsmp/src/sys/dev/xe/if_xe.c	2005/08/05 14:11:40
@@ -411,8 +411,8 @@
   xe_setmedia(scp);
 
   /* Enable output */
-  scp->ifp->if_flags |= IFF_RUNNING;
-  scp->ifp->if_flags &= ~IFF_OACTIVE;
+  scp->ifp->if_drv_flags |= IFF_DRV_RUNNING;
+  scp->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
   (void)splx(s);
 }
@@ -420,8 +420,8 @@
 
 /*
  * Start output on interface.  Should be called at splimp() priority.  Check
- * that the output is idle (ie, IFF_OACTIVE is not set) before calling this
- * function.  If media selection is in progress we set IFF_OACTIVE ourselves
+ * that the output is idle (ie, IFF_DRV_OACTIVE is not set) before calling this
+ * function.  If media selection is in progress we set IFF_DRV_OACTIVE ourselves
  * and return immediately.
  */
 static void
@@ -430,7 +430,7 @@
   struct mbuf *mbp;
 
   if (scp->autoneg_status != XE_AUTONEG_NONE) {
-    ifp->if_flags |= IFF_OACTIVE;
+    ifp->if_drv_flags |= IFF_DRV_OACTIVE;
     return;
   }
 
@@ -451,14 +451,14 @@
        * we haven't filled all the buffers with data then we still want to
        * accept more.
        */
-      ifp->if_flags &= ~IFF_OACTIVE;
+      ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
       return;
     }
 
     if (xe_pio_write_packet(scp, mbp) != 0) {
       /* Push the packet back onto the queue */
       IF_PREPEND(&ifp->if_snd, mbp);
-      ifp->if_flags |= IFF_OACTIVE;
+      ifp->if_drv_flags |= IFF_DRV_OACTIVE;
       return;
     }
 
@@ -496,13 +496,13 @@
      * marked down and running, then stop it.
      */
     if (ifp->if_flags & IFF_UP) {
-      if (!(ifp->if_flags & IFF_RUNNING)) {
+      if (!(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 	xe_reset(scp);
 	xe_init(scp);
       }
     }
     else {
-      if (ifp->if_flags & IFF_RUNNING)
+      if (ifp->if_drv_flags & IFF_DRV_RUNNING)
 	xe_stop(scp);
     }
     /* FALL THROUGH  (handle changes to PROMISC/ALLMULTI flags) */
@@ -630,7 +630,7 @@
 	}
       }
       ifp->if_timer = 0;
-      ifp->if_flags &= ~IFF_OACTIVE;
+      ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
     }
 
     /* Handle most MAC interrupts */
@@ -935,7 +935,7 @@
 
     case XE_AUTONEG_NONE:
       DEVPRINTF(2, (scp->dev, "Waiting for idle transmitter\n"));
-      scp->ifp->if_flags |= IFF_OACTIVE;
+      scp->ifp->if_drv_flags |= IFF_DRV_OACTIVE;
       scp->autoneg_status = XE_AUTONEG_WAITING;
       /* FALL THROUGH */
 
@@ -1129,7 +1129,7 @@
 
   /* Restart output? */
   xe_enable_intr(scp);
-  scp->ifp->if_flags &= ~IFF_OACTIVE;
+  scp->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
   xe_start(scp->ifp);
 }
 
@@ -1198,10 +1198,10 @@
   }
 
   /*
-   * ~IFF_RUNNING == interface down.
+   * ~IFF_DRV_RUNNING == interface down.
    */
-  scp->ifp->if_flags &= ~IFF_RUNNING;
-  scp->ifp->if_flags &= ~IFF_OACTIVE;
+  scp->ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
+  scp->ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
   scp->ifp->if_timer = 0;
 
   (void)splx(s);
--- //depot/vendor/freebsd/src/sys/dev/xe/if_xe_pccard.c	2005/07/15 06:50:31
+++ //depot/projects/netsmp/src/sys/dev/xe/if_xe_pccard.c	2005/08/05 14:11:40
@@ -350,7 +350,7 @@
 
 	DEVPRINTF(2, (dev, "pccard_detach\n"));
 
-	sc->ifp->if_flags &= ~IFF_RUNNING;
+	sc->ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	ether_ifdetach(sc->ifp);
 	if_free(sc->ifp);
 	xe_deactivate(dev);
--- //depot/vendor/freebsd/src/sys/i386/conf/GENERIC	2005/07/14 15:40:25
+++ //depot/projects/netsmp/src/sys/i386/conf/GENERIC	2005/07/22 22:39:00
@@ -27,6 +27,8 @@
 # To statically compile in device wiring instead of /boot/device.hints
 #hints		"GENERIC.hints"		# Default places to look for devices.
 
+options 	BREAK_TO_DEBUGGER
+
 makeoptions	DEBUG=-g		# Build kernel with gdb(1) debug symbols
 
 #options 	SCHED_ULE		# ULE scheduler
--- //depot/vendor/freebsd/src/sys/i386/isa/if_el.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/i386/isa/if_el.c	2005/08/05 14:11:40
@@ -386,8 +386,8 @@
 	CSR_WRITE_1(sc,EL_AC,(EL_AC_IRQE|EL_AC_RX));
 
 	/* Set flags appropriately */
-	ifp->if_flags |= IFF_RUNNING;
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	/* And start output. */
 	el_start(ifp);
@@ -413,9 +413,9 @@
 	EL_LOCK(sc);
 
 	/* Don't do anything if output is active */
-	if(sc->el_ifp->if_flags & IFF_OACTIVE)
+	if(sc->el_ifp->if_drv_flags & IFF_DRV_OACTIVE)
 		return;
-	sc->el_ifp->if_flags |= IFF_OACTIVE;
+	sc->el_ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 
 	/* The main loop.  They warned me against endless loops, but
 	 * would I listen?  NOOO....
@@ -426,7 +426,7 @@
 
 		/* If there's nothing to send, return. */
 		if(m0 == NULL) {
-			sc->el_ifp->if_flags &= ~IFF_OACTIVE;
+			sc->el_ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 			EL_UNLOCK(sc);
 			return;
 		}
@@ -744,15 +744,15 @@
 		 * If interface is marked down and it is running, then stop it
 		 */
 		if (((ifp->if_flags & IFF_UP) == 0) &&
-		    (ifp->if_flags & IFF_RUNNING)) {
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 			el_stop(ifp->if_softc);
-			ifp->if_flags &= ~IFF_RUNNING;
+			ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 		} else {
 		/*
 		 * If interface is marked up and it is stopped, then start it
 		 */
 			if ((ifp->if_flags & IFF_UP) &&
-		    	    ((ifp->if_flags & IFF_RUNNING) == 0))
+		    	    ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0))
 				el_init(ifp->if_softc);
 		}
 		break;
--- //depot/vendor/freebsd/src/sys/i4b/driver/i4b_ipr.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/i4b/driver/i4b_ipr.c	2005/08/05 14:11:40
@@ -444,12 +444,13 @@
 		case SIOCSIFFLAGS:	/* set interface flags */
 			if(!(ifr->ifr_flags & IFF_UP))
 			{
-				if(sc->sc_ifp->if_flags & IFF_RUNNING)
+				if(sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 				{
 					/* disconnect ISDN line */
 					i4b_l4_drvrdisc(BDRV_IPR,
 					    ifp->if_dunit);
-					sc->sc_ifp->if_flags &= ~IFF_RUNNING;
+					sc->sc_ifp->if_drv_flags &=
+					    ~IFF_DRV_RUNNING;
 				}
 
 				sc->sc_state = ST_IDLE;
@@ -594,7 +595,7 @@
 
 	NDBGL4(L4_DIALST, "ipr%d: setting dial state to ST_CONNECTED", unit);
 
-	sc->sc_ifp->if_flags |= IFF_RUNNING;
+	sc->sc_ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	sc->sc_state = ST_CONNECTED_W;
 
 	sc->sc_dialresp = DSTAT_NONE;
@@ -687,7 +688,7 @@
 	sc->sc_dialresp = DSTAT_NONE;
 	sc->sc_lastdialresp = DSTAT_NONE;	
 
-	sc->sc_ifp->if_flags &= ~IFF_RUNNING;
+	sc->sc_ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 	sc->sc_state = ST_IDLE;
 }
 
--- //depot/vendor/freebsd/src/sys/i4b/driver/i4b_isppp.c	2005/06/17 23:55:29
+++ //depot/projects/netsmp/src/sys/i4b/driver/i4b_isppp.c	2005/08/05 14:11:40
@@ -280,7 +280,7 @@
 
 	/*
 	 * s = splimp();
-	 * ifp->if_flags |= IFF_OACTIVE; // - need to clear this somewhere
+	 * ifp->if_drv_flags |= IFF_DRV_OACTIVE; // - need to clear this somewhere
 	 * splx(s);
 	 */
 
--- //depot/vendor/freebsd/src/sys/kern/kern_poll.c	2005/02/25 22:10:33
+++ //depot/projects/netsmp/src/sys/kern/kern_poll.c	2005/08/05 14:11:40
@@ -66,7 +66,7 @@
  *  POLL_DEREGISTER: deregister and return to interrupt mode.
  *
  * The first two commands are only issued if the interface is marked as
- * 'IFF_UP and IFF_RUNNING', the last one only if IFF_RUNNING is set.
+ * 'IFF_UP and IFF_DRV_RUNNING', the last one only if IFF_DRV_RUNNING is set.
  *
  * The count limit specifies how much work the handler can do during the
  * call -- typically this is the number of packets to be received, or
@@ -251,8 +251,9 @@
 	if (count > poll_each_burst)
 		count = poll_each_burst;
 	for (i = 0 ; i < poll_handlers ; i++)
-		if (pr[i].handler && (IFF_UP|IFF_RUNNING) ==
-		    (pr[i].ifp->if_flags & (IFF_UP|IFF_RUNNING)) )
+		if (pr[i].handler &&
+		    (pr[i].ifp->if_flags & IFF_UP) &&
+		    (pr[i].ifp->if_drv_flags & IFF_DRV_RUNNING))
 			pr[i].handler(pr[i].ifp, 0, count); /* quick check */
 	mtx_unlock(&Giant);
 }
@@ -373,13 +374,14 @@
 
 	if (polling) {
 		for (i = 0 ; i < poll_handlers ; i++)
-			if (pr[i].handler && (IFF_UP|IFF_RUNNING) ==
-			    (pr[i].ifp->if_flags & (IFF_UP|IFF_RUNNING)) )
+			if (pr[i].handler &&
+			    (pr[i].ifp->if_flags & IFF_UP) &&
+			    (pr[i].ifp->if_drv_flags & IFF_DRV_RUNNING))
 				pr[i].handler(pr[i].ifp, arg, cycles);
 	} else {	/* unregister */
 		for (i = 0 ; i < poll_handlers ; i++) {
 			if (pr[i].handler &&
-			    pr[i].ifp->if_flags & IFF_RUNNING) {
+			    pr[i].ifp->if_drv_flags & IFF_DRV_RUNNING) {
 				pr[i].ifp->if_flags &= ~IFF_POLLING;
 				pr[i].handler(pr[i].ifp, POLL_DEREGISTER, 1);
 			}
--- //depot/vendor/freebsd/src/sys/net/bridge.c	2005/07/03 18:25:19
+++ //depot/projects/netsmp/src/sys/net/bridge.c	2005/08/05 14:11:40
@@ -908,7 +908,8 @@
     return (BDG_USED(ifp)
 	&& !BDG_MUTED(ifp)
 	&& !_IF_QFULL(&ifp->if_snd)
-	&& (ifp->if_flags & (IFF_UP|IFF_RUNNING)) == (IFF_UP|IFF_RUNNING)
+	&& (ifp->if_flags & IFF_UP)
+	&& (ifp->if_drv_flags & IFF_DRV_RUNNING)
 	&& ifp != src
 	&& BDG_SAMECLUSTER(ifp, dst));
 }
--- //depot/vendor/freebsd/src/sys/net/bridgestp.c	2005/07/06 01:25:25
+++ //depot/projects/netsmp/src/sys/net/bridgestp.c	2005/08/05 14:11:40
@@ -228,7 +228,7 @@
 
 	ifp = bif->bif_ifp;
 
-	if ((ifp->if_flags & IFF_RUNNING) == 0)
+	if ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0)
 		return;
 
 	MGETHDR(m, M_DONTWAIT, MT_DATA);
@@ -370,7 +370,7 @@
 
 	BRIDGE_LOCK_ASSERT(sc);
 
-	if ((ifp->if_flags & IFF_RUNNING) == 0)
+	if ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0)
 		return;
 
 	MGETHDR(m, M_DONTWAIT, MT_DATA);
@@ -1137,7 +1137,7 @@
 			bstp_hold_timer_expiry(sc, bif);
 	}
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		callout_reset(&sc->sc_bstpcallout, hz, bstp_tick, sc);
 
 	BRIDGE_UNLOCK(sc);
--- //depot/vendor/freebsd/src/sys/net/if.c	2005/08/04 14:40:30
+++ //depot/projects/netsmp/src/sys/net/if.c	2005/08/05 14:21:31
@@ -1030,6 +1030,8 @@
 {
 	struct ifaddr *ifa;
 
+	KASSERT(flag == IFF_UP, ("if_unroute: flag != IFF_UP"));
+
 	ifp->if_flags &= ~flag;
 	getmicrotime(&ifp->if_lastchange);
 	TAILQ_FOREACH(ifa, &ifp->if_addrhead, ifa_link)
@@ -1053,6 +1055,8 @@
 {
 	struct ifaddr *ifa;
 
+	KASSERT(flag == IFF_UP, ("if_route: flag != IFF_UP"));
+
 	ifp->if_flags |= flag;
 	getmicrotime(&ifp->if_lastchange);
 	TAILQ_FOREACH(ifa, &ifp->if_addrhead, ifa_link)
@@ -1230,7 +1234,7 @@
 	struct ifreq *ifr;
 	struct ifstat *ifs;
 	int error = 0;
-	int new_flags;
+	int new_flags, temp_flags;
 	size_t namelen, onamelen;
 	char new_name[IFNAMSIZ];
 	struct ifaddr *ifa;
@@ -1243,8 +1247,9 @@
 		break;
 
 	case SIOCGIFFLAGS:
-		ifr->ifr_flags = ifp->if_flags & 0xffff;
-		ifr->ifr_flagshigh = ifp->if_flags >> 16;
+		temp_flags = ifp->if_flags | ifp->if_drv_flags;
+		ifr->ifr_flags = temp_flags & 0xffff;
+		ifr->ifr_flagshigh = temp_flags >> 16;
 		break;
 
 	case SIOCGIFCAP:
@@ -1274,6 +1279,11 @@
 		error = suser(td);
 		if (error)
 			return (error);
+		/*
+		 * XXXRW: Currently, no driver owned flags pass the
+		 * IFF_CANTCHANGE check, so we don't need special handling
+		 * here yet.
+		 */
 		new_flags = (ifr->ifr_flags & 0xffff) |
 		    (ifr->ifr_flagshigh << 16);
 		if (ifp->if_flags & IFF_SMART) {
@@ -1611,10 +1621,12 @@
 }
 
 /*
- * The code common to hadling reference counted flags,
+ * The code common to handling reference counted flags,
  * e.g., in ifpromisc() and if_allmulti().
  * The "pflag" argument can specify a permanent mode flag,
  * such as IFF_PPROMISC for promiscuous mode; should be 0 if none.
+ *
+ * XXXRW: Only to be used on stack-owned flags, not driver-owned flags.
  */
 static int
 if_setflag(struct ifnet *ifp, int flag, int pflag, int *refcount, int onswitch)
@@ -1623,6 +1635,9 @@
 	int error;
 	int oldflags, oldcount;
 
+	KASSERT((flag & (IFF_DRV_OACTIVE|IFF_DRV_RUNNING)) == 0,
+	    ("if_setflag: setting driver-ownded flag %d", flag));
+
 	/* Sanity checks to catch programming errors */
 	if (onswitch) {
 		if (*refcount < 0) {
@@ -2259,7 +2274,11 @@
 		ifp->if_obytes += m->m_pkthdr.len + adjust;
 		if (m->m_flags & (M_BCAST|M_MCAST))
 			ifp->if_omcasts++;
-		active = ifp->if_flags & IFF_OACTIVE;
+		/*
+		 * XXXRW: Technically, we'd like the driver to do this to
+		 * avoid races.
+		 */
+		active = ifp->if_drv_flags & IFF_DRV_OACTIVE;
 	}
 	_IF_ENQUEUE(ifq, m);
 	IF_UNLOCK(ifq);
--- //depot/vendor/freebsd/src/sys/net/if.h	2005/06/05 03:15:31
+++ //depot/projects/netsmp/src/sys/net/if.h	2005/08/04 13:01:38
@@ -109,17 +109,33 @@
 	struct	timeval ifi_lastchange;	/* time of last administrative change */
 };
 
+/*
+ * Interface flags are of two types: network stack owned flags, and driver
+ * owned flags.  Historically, these values were stored in the same ifnet
+ * flags field, but with the advent of fine-grained locking, they have been
+ * broken out such that the network stack is responsible for synchronizing
+ * the stack-owned fields, and the device driver the device-owned fields.
+ * Both halves can perform lockless reads of the other half's field, subject
+ * to accepting the involved races.
+ *
+ * Both sets of flags come from the same number space, and should not be
+ * permitted to conflict, as they are exposed to user space via a single
+ * field.
+ *
+ * For historical reasons, the old flag names for driver flags are exposed to
+ * user space.
+ */
 #define	IFF_UP		0x1		/* interface is up */
 #define	IFF_BROADCAST	0x2		/* broadcast address valid */
 #define	IFF_DEBUG	0x4		/* turn on debugging */
 #define	IFF_LOOPBACK	0x8		/* is a loopback net */
 #define	IFF_POINTOPOINT	0x10		/* interface is point-to-point link */
 #define	IFF_SMART	0x20		/* interface manages own routes */
-#define	IFF_RUNNING	0x40		/* resources allocated */
+#define	IFF_DRV_RUNNING	0x40		/* resources allocated */
 #define	IFF_NOARP	0x80		/* no address resolution protocol */
 #define	IFF_PROMISC	0x100		/* receive all packets */
 #define	IFF_ALLMULTI	0x200		/* receive all multicast packets */
-#define	IFF_OACTIVE	0x400		/* tx hardware queue is full */
+#define	IFF_DRV_OACTIVE	0x400		/* tx hardware queue is full */
 #define	IFF_SIMPLEX	0x800		/* can't hear own transmissions */
 #define	IFF_LINK0	0x1000		/* per link layer defined bit */
 #define	IFF_LINK1	0x2000		/* per link layer defined bit */
@@ -132,9 +148,18 @@
 #define	IFF_STATICARP	0x80000		/* static ARP */
 #define	IFF_NEEDSGIANT	0x100000	/* hold Giant over if_start calls */
 
+/*
+ * Old names for driver flags so that user space tools can continue to use
+ * the old names.
+ */
+#ifndef _KERNEL
+#define	IFF_RUNNING	IFF_DRV_RUNNING
+#define	IFF_OACTIVE	IFF_DRV_OACTIVE
+#endif
+
 /* flags set internally only: */
 #define	IFF_CANTCHANGE \
-	(IFF_BROADCAST|IFF_POINTOPOINT|IFF_RUNNING|IFF_OACTIVE|\
+	(IFF_BROADCAST|IFF_POINTOPOINT|IFF_DRV_RUNNING|IFF_DRV_OACTIVE|\
 	    IFF_SIMPLEX|IFF_MULTICAST|IFF_ALLMULTI|IFF_SMART|IFF_PROMISC|\
 	    IFF_POLLING)
 
--- //depot/vendor/freebsd/src/sys/net/if_arcsubr.c	2005/08/02 17:55:56
+++ //depot/projects/netsmp/src/sys/net/if_arcsubr.c	2005/08/05 14:11:40
@@ -112,7 +112,8 @@
 	int			loop_copy = 0;
 	int			isphds;
 
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		return(ENETDOWN); /* m, m1 aren't initialized yet */
 
 	error = 0;
--- //depot/vendor/freebsd/src/sys/net/if_atm.h	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/net/if_atm.h	2005/08/05 14:11:40
@@ -320,8 +320,8 @@
 #define	ATMEV_SEND_IFSTATE_CHANGED(ATMIF, CARRIER)			\
 	do {								\
 		struct atmev_ifstate_changed _arg;			\
-		_arg.running = (((ATMIF)->ifp->if_flags &		\
-		    IFF_RUNNING) != 0);					\
+		_arg.running = (((ATMIF)->ifp->if_drv_flags &		\
+		    IFF_DRV_RUNNING) != 0);				\
 		_arg.carrier = ((CARRIER) != 0);			\
 		atm_event((ATMIF)->ifp, ATMEV_IFSTATE_CHANGED, &_arg); \
 	} while (0)
--- //depot/vendor/freebsd/src/sys/net/if_atmsubr.c	2005/07/18 17:00:51
+++ //depot/projects/netsmp/src/sys/net/if_atmsubr.c	2005/08/05 14:11:40
@@ -138,7 +138,8 @@
 		senderr(error);
 #endif
 
-	if ((ifp->if_flags & (IFF_UP | IFF_RUNNING)) != (IFF_UP | IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		senderr(ENETDOWN);
 
 	/*
--- //depot/vendor/freebsd/src/sys/net/if_bridge.c	2005/07/25 02:25:32
+++ //depot/projects/netsmp/src/sys/net/if_bridge.c	2005/08/05 14:11:40
@@ -584,13 +584,15 @@
 		break;
 
 	case SIOCSIFFLAGS:
-		if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) == IFF_RUNNING) {
+		if (!(ifp->if_flags & IFF_UP) &&
+		    (ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 			/*
 			 * If interface is marked down and it is running,
 			 * then stop and disable it.
 			 */
 			bridge_stop(ifp, 1);
-		} else if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) == IFF_UP) {
+		} else if ((ifp->if_flags & IFF_UP) &&
+		    !(ifp->if_drv_flags & IFF_DRV_RUNNING)) {
 			/*
 			 * If interface is marked up and it is stopped, then
 			 * start it.
@@ -699,7 +701,7 @@
 
 	free(bif, M_DEVBUF);
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 }
 
@@ -764,7 +766,7 @@
 	 */
 	LIST_INSERT_HEAD(&sc->sc_iflist, bif, bif_next);
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 	else
 		bstp_stop(sc);
@@ -841,7 +843,7 @@
 
 	bif->bif_flags = req->ifbr_ifsflags;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1042,7 +1044,7 @@
 
 	sc->sc_bridge_priority = param->ifbrp_prio;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1071,7 +1073,7 @@
 		return (EINVAL);
 	sc->sc_bridge_hello_time = param->ifbrp_hellotime << 8;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1100,7 +1102,7 @@
 		return (EINVAL);
 	sc->sc_bridge_forward_delay = param->ifbrp_fwddelay << 8;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1129,7 +1131,7 @@
 		return (EINVAL);
 	sc->sc_bridge_max_age = param->ifbrp_maxage << 8;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1149,7 +1151,7 @@
 
 	bif->bif_priority = req->ifbr_priority;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1169,7 +1171,7 @@
 
 	bif->bif_path_cost = req->ifbr_path_cost;
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		bstp_initialization(sc);
 
 	return (0);
@@ -1206,13 +1208,13 @@
 	struct bridge_softc *sc = (struct bridge_softc *)xsc;
 	struct ifnet *ifp = sc->sc_ifp;
 
-	if (ifp->if_flags & IFF_RUNNING)
+	if (ifp->if_drv_flags & IFF_DRV_RUNNING)
 		return;
 
 	callout_reset(&sc->sc_brcallout, bridge_rtable_prune_period * hz,
 	    bridge_timer, sc);
 
-	ifp->if_flags |= IFF_RUNNING;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
 	bstp_initialization(sc);
 	return;
 }
@@ -1227,7 +1229,7 @@
 {
 	struct bridge_softc *sc = ifp->if_softc;
 
-	if ((ifp->if_flags & IFF_RUNNING) == 0)
+	if ((ifp->if_drv_flags & IFF_DRV_RUNNING) == 0)
 		return;
 
 	callout_stop(&sc->sc_brcallout);
@@ -1235,7 +1237,7 @@
 
 	bridge_rtflush(sc, IFBF_FLUSHDYN);
 
-	ifp->if_flags &= ~IFF_RUNNING;
+	ifp->if_drv_flags &= ~IFF_DRV_RUNNING;
 }
 
 /*
@@ -1279,7 +1281,7 @@
 		}
 	}
 
-	if ((dst_ifp->if_flags & IFF_OACTIVE) == 0)
+	if ((dst_ifp->if_drv_flags & IFF_DRV_OACTIVE) == 0)
 		(*dst_ifp->if_start)(dst_ifp);
 }
 
@@ -1356,7 +1358,7 @@
 	 * go ahead and send out that interface.  Otherwise, the packet
 	 * is dropped below.
 	 */
-	if ((sc->sc_ifp->if_flags & IFF_RUNNING) == 0) {
+	if ((sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 		dst_if = ifp;
 		goto sendunicast;
 	}
@@ -1381,7 +1383,7 @@
 		}
 		LIST_FOREACH(bif, &sc->sc_iflist, bif_next) {
 			dst_if = bif->bif_ifp;
-			if ((dst_if->if_flags & IFF_RUNNING) == 0)
+			if ((dst_if->if_drv_flags & IFF_DRV_RUNNING) == 0)
 				continue;
 
 			/*
@@ -1424,7 +1426,7 @@
 	 * XXX Spanning tree consideration here?
 	 */
 
-	if ((dst_if->if_flags & IFF_RUNNING) == 0) {
+	if ((dst_if->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 		m_freem(m);
 		BRIDGE_UNLOCK(sc);
 		return (0);
@@ -1451,7 +1453,7 @@
 
 	sc = ifp->if_softc;
 
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 	for (;;) {
 		IFQ_DEQUEUE(&ifp->if_snd, m);
 		if (m == 0)
@@ -1485,7 +1487,7 @@
 			bridge_enqueue(sc, dst_if, m);
 		}
 	}
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 
 	return;
 }
@@ -1607,7 +1609,7 @@
 	 * At this point, we're dealing with a unicast frame
 	 * going to a different interface.
 	 */
-	if ((dst_if->if_flags & IFF_RUNNING) == 0) {
+	if ((dst_if->if_drv_flags & IFF_DRV_RUNNING) == 0) {
 		BRIDGE_UNLOCK(sc);
 		m_freem(m);
 		return;
@@ -1663,7 +1665,7 @@
 	struct ether_header *eh;
 	struct mbuf *mc;
 
-	if ((sc->sc_ifp->if_flags & IFF_RUNNING) == 0)
+	if ((sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING) == 0)
 		return (m);
 
 	BRIDGE_LOCK(sc);
@@ -1829,7 +1831,7 @@
 		    (m->m_flags & (M_BCAST|M_MCAST)) == 0)
 			continue;
 
-		if ((dst_if->if_flags & IFF_RUNNING) == 0)
+		if ((dst_if->if_drv_flags & IFF_DRV_RUNNING) == 0)
 			continue;
 
 		if (LIST_NEXT(bif, bif_next) == NULL) {
@@ -1985,7 +1987,7 @@
 	bridge_rtage(sc);
 	BRIDGE_UNLOCK(sc);
 
-	if (sc->sc_ifp->if_flags & IFF_RUNNING)
+	if (sc->sc_ifp->if_drv_flags & IFF_DRV_RUNNING)
 		callout_reset(&sc->sc_brcallout,
 		    bridge_rtable_prune_period * hz, bridge_timer, sc);
 }
--- //depot/vendor/freebsd/src/sys/net/if_ef.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/net/if_ef.c	2005/08/05 14:11:40
@@ -143,7 +143,7 @@
 
 	ifp->if_resolvemulti = 0;
 	ifp->if_type = IFT_XETHER;
-	ifp->if_flags |= IFF_RUNNING;
+	ifp->if_drv_flags |= IFF_DRV_RUNNING;
 
 	EFDEBUG("%s: attached\n", ifp->if_xname);
 	return 1;
@@ -214,7 +214,7 @@
 	struct mbuf *m;
 	int error;
 
-	ifp->if_flags |= IFF_OACTIVE;
+	ifp->if_drv_flags |= IFF_DRV_OACTIVE;
 	p = sc->ef_pifp;
 
 	EFDEBUG("\n");
@@ -230,7 +230,7 @@
 		}
 		ifp->if_opackets++;
 	}
-	ifp->if_flags &= ~IFF_OACTIVE;
+	ifp->if_drv_flags &= ~IFF_DRV_OACTIVE;
 	return;
 }
 
--- //depot/vendor/freebsd/src/sys/net/if_ethersubr.c	2005/08/02 17:55:56
+++ //depot/projects/netsmp/src/sys/net/if_ethersubr.c	2005/08/05 14:11:40
@@ -163,7 +163,8 @@
 
 	if (ifp->if_flags & IFF_MONITOR)
 		senderr(ENETDOWN);
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		senderr(ENETDOWN);
 
 	hlen = ETHER_HDR_LEN;
--- //depot/vendor/freebsd/src/sys/net/if_faith.c	2005/06/26 18:15:33
+++ //depot/projects/netsmp/src/sys/net/if_faith.c	2005/08/05 14:11:40
@@ -300,7 +300,8 @@
 	switch (cmd) {
 
 	case SIOCSIFADDR:
-		ifp->if_flags |= IFF_UP | IFF_RUNNING;
+		ifp->if_flags |= IFF_UP;
+		ifp->if_drv_flags |= IFF_DRV_RUNNING;
 		ifa = (struct ifaddr *)data;
 		ifa->ifa_rtrequest = faithrtrequest;
 		/*
--- //depot/vendor/freebsd/src/sys/net/if_fddisubr.c	2005/08/02 17:55:56
+++ //depot/projects/netsmp/src/sys/net/if_fddisubr.c	2005/08/05 14:11:40
@@ -127,7 +127,8 @@
 
 	if (ifp->if_flags & IFF_MONITOR)
 		senderr(ENETDOWN);
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		senderr(ENETDOWN);
 	getmicrotime(&ifp->if_lastchange);
 
@@ -387,7 +388,8 @@
 	/*
 	 * Discard packet if interface is not up.
 	 */
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING))
+	if (!((ifp->if_flags & IFF_UP) &&
+	    (ifp->if_drv_flags & IFF_DRV_RUNNING)))
 		goto dropanyway;
 
 	/*
--- //depot/vendor/freebsd/src/sys/net/if_fwsubr.c	2005/06/10 16:51:34
+++ //depot/projects/netsmp/src/sys/net/if_fwsubr.c	2005/08/05 14:11:40
@@ -97,7 +97,8 @@
 		goto bad;
 #endif
 
-	if ((ifp->if_flags & (IFF_UP|IFF_RUNNING)) != (IFF_UP|IFF_RUNNING)) {
+	if (!((ifp->if_flags & IFF_UP) &&
+	   (ifp->if_drv_flags & IFF_DRV_RUNNING))) {
 		error = ENETDOWN;
 		goto bad;
 	}
